ghc-8.2.2: The GHC API

Safe Haskell | None
Language | Haskell2010

TcMatches

# Documentation

tcMatchesFun :: Located Name -> MatchGroup Name (LHsExpr Name) -> ExpRhoType -> TcM (HsWrapper, MatchGroup TcId (LHsExpr TcId)) #

tcGRHS :: TcMatchCtxt body -> ExpRhoType -> GRHS Name (Located (body Name)) -> TcM (GRHS TcId (Located (body TcId))) #

tcGRHSsPat :: GRHSs Name (LHsExpr Name) -> TcRhoType -> TcM (GRHSs TcId (LHsExpr TcId)) #

tcMatchesCase :: Outputable (body Name) => TcMatchCtxt body -> TcSigmaType -> MatchGroup Name (Located (body Name)) -> ExpRhoType -> TcM (MatchGroup TcId (Located (body TcId))) #

tcMatchLambda :: SDoc -> TcMatchCtxt HsExpr -> MatchGroup Name (LHsExpr Name) -> ExpRhoType -> TcM (MatchGroup TcId (LHsExpr TcId), HsWrapper) #

data TcMatchCtxt body #

Constructors

MC |

Fields

- mc_what :: HsMatchContext Name
- mc_body :: Located (body Name) -> ExpRhoType -> TcM (Located (body TcId))

type TcStmtChecker body rho_type = forall thing. HsStmtContext Name -> Stmt Name (Located (body Name)) -> rho_type -> (rho_type -> TcM thing) -> TcM (Stmt TcId (Located (body TcId)), thing) #

type TcExprStmtChecker = TcStmtChecker HsExpr ExpRhoType #

type TcCmdStmtChecker = TcStmtChecker HsCmd TcRhoType #

tcStmts :: Outputable (body Name) => HsStmtContext Name -> TcStmtChecker body rho_type -> [LStmt Name (Located (body Name))] -> rho_type -> TcM [LStmt TcId (Located (body TcId))] #

tcStmtsAndThen :: Outputable (body Name) => HsStmtContext Name -> TcStmtChecker body rho_type -> [LStmt Name (Located (body Name))] -> rho_type -> (rho_type -> TcM thing) -> TcM ([LStmt TcId (Located (body TcId))], thing) #

tcDoStmts :: HsStmtContext Name -> Located [LStmt Name (LHsExpr Name)] -> ExpRhoType -> TcM (HsExpr TcId) #

tcBody :: LHsExpr Name -> ExpRhoType -> TcM (LHsExpr TcId) #

tcDoStmt :: TcExprStmtChecker #

tcGuardStmt :: TcExprStmtChecker #